/*
 * Hashing from the Ground Up
 * by Javantea
 * Feb 20, 2008
 *
 * Description: A set of hashing algorithms that are small enough to put into 
 * shellcode. Obviously depending on how short it needs to be, you'll want to 
 * use the defines to put one into your shellcode. Don't use libc you idiot!
 */

#ifdef HASH_SHELLCODE2

void write_stdio(char *data, int len);

#endif // HASH_SHELLCODE2

#ifdef STDLIB

// Pretty funny way to get printf =).
#define get_myprintf printf

#else

// For now dl_lib is not working.
//(void (*)(char *, ...))get_sym_all("printf");
#define get_myprintf 0

#endif // STDLIB

#define USE_ASHASH1

#ifdef USE_ASHASH1

/* AltSci Hash 1
 * As simple as I can think of without breaking my mind. It is not secure, it 
is assume to be a worthless source of random, and can be thought of as a 
function that returns a deterministic, reversable long given data that doesn't 
get input at all.
 */
typedef struct ASHASH1 {
	unsigned long hash;
} ASHASH1;
//typedef unsigned long ASHASH1;

ASHASH1 ashash1(char *data, int length)
{
	ASHASH1 output;
	output.hash = 1049602669;
	int i;
	unsigned char r = 4;
	unsigned long b;
	unsigned char ls;
	for(i = 0; i < length; i++)
	{
		ls = r % 17;
		// At this point b is a maximum of 16 bits.
		b = (data[i] * (r+1));
#ifdef VERBOSE
		printf("b = %i\n", b);
		printf("r = %i\n", r);
#endif // VERBOSE
		// r grabs the least 8 bits of b + 59.
		r = b + 59;
		// Use a left shift to make b modify the hash in a random way.
		b <<= ls;
		output.hash += b;
	}
	return output;
}

// Length of output is always exactly twice input + 1 null.
// Don't forget kiddies.
void bintohex(char *output, char *bin, int length)
{
	int i;
	for(i = 0; i < length; i++)
	{
		char left = (bin[i] & 0xf);
		if(left > 9) left += 'a' - 9;
		else         left += '0';
		char right = (bin[i] & 0xf0) >> 4;
		if(right > 9) right += 'a' - 9;
		else          right += '0';
		output[2 * i    ] = left;
		output[2 * i + 1] = right;
	}
}

#endif // USE_ASHASH1

#ifndef LIBRARY

// This is a funny little hack that turns main into ashash1_main if we don't 
// define TEST_LIBRARY or LIBRARY.
#ifdef TEST_LIBRARY
#define ashash1_main main
#endif // TEST_LIBRARY

#include <stdio.h>
#include "dl2.h"

int ashash1_main(int argc, char **argv)
{
	void (*my_printf)(char *, ...);
	my_printf = get_myprintf;
	char input[] = "This is a tesT.";
	int length = sizeof(input);
#ifdef USE_ASHASH1
	if(my_printf)
		my_printf("ashash1(\"%s\", %i)", input, length);
#ifdef HASH_SHELLCODE2
	else {
		write_stdio("ashash1(\"", 9);
		write_stdio(input, length-1);
		write_stdio("\", 0x", 5);
		char tmp1[9];
		tmp1[8] = 0;
		bintohex(tmp1, (char *)&length, 4);
		write_stdio(tmp1, 8);
		write_stdio(")", 1);
	}
#endif // HASH_SHELLCODE2
	ASHASH1 output = ashash1(input, length);
	if(my_printf)
		my_printf(" == %08x;\n", (unsigned int)output.hash);
#ifdef HASH_SHELLCODE2
	else {
		write_stdio(" == ", 4);
		char tmp2[9];
		tmp2[8] = 0;
		bintohex(tmp2, (char *)&output.hash, 4);
		write_stdio(tmp2, 8);
		write_stdio(";\n", 2);
	}
#endif // HASH_SHELLCODE2
#endif // USE_ASHASH1
	return 0;
}

#endif // !LIBRARY
